## gvm-libs 22.33.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

cmake_minimum_required(VERSION 3.5)

message("-- Configuring the Greenbone Vulnerability Management Libraries...")

# VERSION: Always include major, minor and patch level.
project(gvm-libs VERSION 22.33.0 LANGUAGES C)

if(POLICY CMP0005)
  cmake_policy(SET CMP0005 NEW)
endif(POLICY CMP0005)

set(C_STANDARD, 11)
set(CMAKE_C_STANDARD 11)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif(NOT CMAKE_BUILD_TYPE)

option(BUILD_STATIC "Build static versions of the libraries" OFF)
option(ENABLE_COVERAGE "Enable support for coverage analysis" OFF)
option(BUILD_TESTS "Build tests for the libraries" OFF)
option(ENABLE_OPENVASD "Build openvasd library" ON)
option(ENABLE_AGENTS "Build agent controller library" ON)
option(ENABLE_CREDENTIAL_STORES "Build credential store library" ON)

if(NOT BUILD_STATIC)
  set(BUILD_SHARED ON)
else(NOT BUILD_STATIC)
  set(BUILD_SHARED OFF)
endif(NOT BUILD_STATIC)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

## Retrieve git revision (at configure time)
find_package(Git)

## make format
message(STATUS "Looking for clang-format...")
find_program(CLANG_FORMAT clang-format)

if(CLANG_FORMAT)
  message(STATUS "Looking for clang-format... ${CLANG_FORMAT}")
  add_custom_target(
    format
    COMMAND
      ${CLANG_FORMAT} "-i" "./agent_controller/*.c" "./base/*.c" "./boreas/*.c"
      "./gmp/*.c" "./http_scanner/*.c" "./openvasd/*.c" "./osp/*.c" "./util/*.c"
      "./agent_controller/*.h" "./base/*.h" "./boreas/*.h" "./gmp/*.h"
      "./http_scanner/*.h" "./openvasd/*.h" "./osp/*.h" "./util/*.h"
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
  )
else(CLANG_FORMAT)
  message(STATUS "clang-format not found...")
endif(CLANG_FORMAT)

include(MacroGitGetRevision)

if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
  if(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
    if(GIT_FOUND)
      git_get_revision(${CMAKE_SOURCE_DIR} ProjectRevision)
      set(GIT_REVISION "~git-${ProjectRevision}")
    else(GIT_FOUND)
      set(GIT_REVISION "~git")
    endif(GIT_FOUND)
  endif(EXISTS "${CMAKE_SOURCE_DIR}/.git/")
endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")

# Set dev version if this is a development version and not a full release,
# unset (put value 0 or delete line) before a full release and reset after.
set(PROJECT_DEV_VERSION 0)

# If PROJECT_DEV_VERSION is set, the version string will be set to:
#   "major.minor.patch~dev${PROJECT_DEV_VERSION}${GIT_REVISION}"
# If PROJECT_DEV_VERSION is NOT set, the version string will be set to:
#   "major.minor.patch${GIT_REVISION}"
# For CMAKE_BUILD_TYPE "Release" the git revision will be empty.
if(PROJECT_DEV_VERSION)
  set(PROJECT_VERSION_SUFFIX "~dev${PROJECT_DEV_VERSION}")
endif(PROJECT_DEV_VERSION)

set(
  PROJECT_VERSION_STRING
  "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}${PROJECT_VERSION_SUFFIX}${GIT_REVISION}"
)

## CPack configuration

set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "TGZ")
set(CPACK_INSTALL_CMAKE_PROJECTS ".;gvm-libs;ALL;/")
set(CPACK_MODULE_PATH "")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_WELCOME "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_TOPLEVEL_TAG "")
set(CPACK_SYSTEM_NAME "")
set(CPACK_TOPLEVEL_TAG "")

set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION_STRING}${PROJECT_VERSION_GIT}")

set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_PACKAGE_VENDOR "Greenbone Networks")
set(CPACK_SOURCE_IGNORE_FILES "${CMAKE_BINARY_DIR}" "/.git/" "swp$")

include(CPack)

## Variables

if(SYSCONF_INSTALL_DIR)
  set(SYSCONFDIR "${SYSCONF_INSTALL_DIR}")
endif(SYSCONF_INSTALL_DIR)

if(NOT SYSCONFDIR)
  set(SYSCONFDIR "/etc")
endif(NOT SYSCONFDIR)

if(NOT EXEC_PREFIX)
  set(EXEC_PREFIX "${CMAKE_INSTALL_PREFIX}")
endif(NOT EXEC_PREFIX)

if(NOT BINDIR)
  set(BINDIR "${EXEC_PREFIX}/bin")
endif(NOT BINDIR)

if(NOT SBINDIR)
  set(SBINDIR "${EXEC_PREFIX}/sbin")
endif(NOT SBINDIR)

if(NOT LIBDIR)
  set(_DEFAULT_LIBRARY_INSTALL_DIR lib)
  if(EXISTS "${EXEC_PREFIX}/lib32/" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(_DEFAULT_LIBRARY_INSTALL_DIR lib32)
  endif(EXISTS "${EXEC_PREFIX}/lib32/" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  if(EXISTS "${CMAKE_INSTALL_PREFIX}/lib64/" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(_DEFAULT_LIBRARY_INSTALL_DIR lib64)
  endif(EXISTS "${CMAKE_INSTALL_PREFIX}/lib64/" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(LIBRARY_INSTALL_DIR "${_DEFAULT_LIBRARY_INSTALL_DIR}")
  set(LIBDIR "${EXEC_PREFIX}/${LIBRARY_INSTALL_DIR}")
endif(NOT LIBDIR)

if(NOT LOCALSTATEDIR)
  set(LOCALSTATEDIR "/var")
endif(NOT LOCALSTATEDIR)

if(NOT INCLUDEDIR)
  set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include")
endif(NOT INCLUDEDIR)

if(NOT DATADIR)
  set(DATADIR "${CMAKE_INSTALL_PREFIX}/share")
endif(NOT DATADIR)

if(NOT GVM_RUN_DIR)
  set(GVM_RUN_DIR "/run/gvm")
endif(NOT GVM_RUN_DIR)

if(NOT GVM_SYSCONF_DIR)
  set(GVM_SYSCONF_DIR "${SYSCONFDIR}/gvm")
endif(NOT GVM_SYSCONF_DIR)

if(NOT REDIS_SOCKET_PATH)
  set(REDIS_SOCKET_PATH "/run/redis/redis.sock")
endif()

add_definitions(-DREDIS_SOCKET_PATH="${REDIS_SOCKET_PATH}")
message("-- Using redis socket ${REDIS_SOCKET_PATH}")

message("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")

if(ENABLE_COVERAGE)
  set(COVERAGE_FLAGS "--coverage -ftest-coverage -fprofile-arcs")
  set(COVERAGE_DIR "${CMAKE_BINARY_DIR}/coverage")
  file(MAKE_DIRECTORY ${COVERAGE_DIR})
  message("-- Code Coverage enabled")
endif(ENABLE_COVERAGE)

set(
  HARDENING_FLAGS
  "-Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector"
)
set(LINKER_HARDENING_FLAGS "-Wl,-z,relro -Wl,-z,now")
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${COVERAGE_FLAGS}")
set(
  CMAKE_C_FLAGS_RELEASE
  "${CMAKE_C_FLAGS_RELEASE} ${HARDENING_FLAGS} ${COVERAGE_FLAGS}"
)

set(
  CMAKE_C_FLAGS
  "${CMAKE_C_FLAGS} ${GPGME_C_FLAGS} \
    -std=c11 \
    -Wall \
    -Wextra \
    -Werror \
    -Wpedantic \
    -Wmissing-prototypes \
    -Wshadow \
    -Wsequence-point \
    -D_ISOC11_SOURCE \
    -D_DEFAULT_SOURCE"
)

## Version

set(LIBGVMCONFIG_VERSION "${PROJECT_VERSION_STRING}")

add_definitions(-DGVM_LIBS_VERSION="${LIBGVMCONFIG_VERSION}")

# Configure Doxyfile with version number
configure_file(doc/Doxyfile.in ${CMAKE_BINARY_DIR}/doc/Doxyfile @ONLY)
configure_file(doc/Doxyfile_full.in ${CMAKE_BINARY_DIR}/doc/Doxyfile_full @ONLY)
configure_file(doc/Doxyfile_xml.in ${CMAKE_BINARY_DIR}/doc/Doxyfile_xml @ONLY)
configure_file(VERSION.in ${CMAKE_BINARY_DIR}/VERSION @ONLY)

## Testing

if(BUILD_TESTS AND NOT SKIP_SRC)
  message("-- Tests enabled.")
  enable_testing()

  include(MacroAddUnitTest)

  find_package(cgreen REQUIRED)

  set(
    TESTS
    array-test
    boreas-alivedetection-test
    boreas-cli-test
    boreas-error-test
    boreas-io-test
    boreas-ping-test
    boreas-sniffer-test
    compressutils-test
    cpeutils-test
    cvss-test
    hosts-test
    json-test
    jsonpull-test
    logging-test
    logging-domain-test
    networking-test
    nvti-test
    osp-test
    passwordbasedauthentication-test
    streamvalidator-test
    test-hosts
    util-test
    version-test
    versionutils-test
    xmlutils-test
  )

  if(ENABLE_OPENVASD)
    list(
      APPEND TESTS
      openvasd-test
      http-scanner-test
      container_image_scanner-test
      httputils-test
      vtparser-test
    )
  endif(ENABLE_OPENVASD)

  if(ENABLE_AGENTS)
    list(APPEND TESTS agent-controller-test)
  endif(ENABLE_AGENTS)

  add_custom_target(tests DEPENDS ${TESTS})

  # Code coverage
  if(ENABLE_COVERAGE)
    find_program(GCOVR gcovr)

    if(NOT GCOVR)
      message(FATAL_ERROR "gcovr coverage reporting tool not found")
    endif()

    message("-- Code Coverage Reporting enabled")

    add_custom_target(
      coverage-html
      COMMAND
        ${GCOVR} --config ${CMAKE_SOURCE_DIR}/.gcovr.cfg --html-details
        ${COVERAGE_DIR}/coverage.html -r ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
      DEPENDS tests
    )
    add_custom_target(
      coverage-xml
      COMMAND
        ${GCOVR} --config ${CMAKE_SOURCE_DIR}/.gcovr.cfg --xml
        ${COVERAGE_DIR}/coverage.xml -r ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
      DEPENDS tests
    )
    add_custom_target(coverage DEPENDS coverage-xml coverage-html)
  endif(ENABLE_COVERAGE)
endif(BUILD_TESTS AND NOT SKIP_SRC)

add_custom_target(
  clean-coverage
  COMMAND find . -name *.gcda -delete -or -name *.gcno -delete
  COMMAND rm -f ${COVERAGE_DIR}/*
)

## Program

if(NOT SKIP_SRC)
  add_subdirectory(base)
  add_subdirectory(boreas)
  add_subdirectory(util)
  add_subdirectory(osp)
  add_subdirectory(gmp)

  if(ENABLE_OPENVASD)
    add_subdirectory(http)
    add_subdirectory(http_scanner)
    add_subdirectory(openvasd)
    add_subdirectory(container_image_scanner)
  endif(ENABLE_OPENVASD)

  if(ENABLE_AGENTS)
    if(NOT ENABLE_OPENVASD)
      add_subdirectory(http)
    endif(NOT ENABLE_OPENVASD)
    add_subdirectory(agent_controller)
  endif(ENABLE_AGENTS)

  if(ENABLE_CREDENTIAL_STORES)
    if(NOT ENABLE_OPENVASD)
      add_subdirectory(http)
    endif(NOT ENABLE_OPENVASD)
    add_subdirectory(cyberark)
  endif(ENABLE_CREDENTIAL_STORES)
endif(NOT SKIP_SRC)

## Documentation

add_subdirectory(doc)

if(BUILD_TESTS AND NOT SKIP_SRC)
  add_subdirectory(tests)
  add_test(NAME testhosts COMMAND test-hosts localhost)
endif(BUILD_TESTS AND NOT SKIP_SRC)

## End

=== debian/changelog ===
gvm-libs (22.33.0-1.pgdg25.10+1) questing-pgdg; urgency=medium

  * Rebuild for questing-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 03 Dec 2025 11:20:44 +0100

gvm-libs (22.33.0-1) unstable; urgency=medium

  * New upstream version 22.33.0
  * Refresh patches
  * Update symbols

 -- Sophie Brun <sophie@kali.org>  Wed, 03 Dec 2025 11:20:44 +0100

## gvm-libs 22.34.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 message("-- Configuring the Greenbone Vulnerability Management Libraries...")
 
 # VERSION: Always include major, minor and patch level.
-project(gvm-libs VERSION 22.33.0 LANGUAGES C)
+project(gvm-libs VERSION 22.34.1 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)

=== debian/changelog ===
gvm-libs (22.34.1-1parrot1) echo; urgency=medium

  * Import new Debian sid version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 18 Dec 2025 19:01:41 +0100

gvm-libs (22.34.1-1) unstable; urgency=medium

  * New upstream version 22.34.1
  * Refresh patches
  * Update symbols

 -- Sophie Brun <sophie@kali.org>  Wed, 17 Dec 2025 11:04:31 +0100

## gvm-libs 22.34.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 message("-- Configuring the Greenbone Vulnerability Management Libraries...")
 
 # VERSION: Always include major, minor and patch level.
-project(gvm-libs VERSION 22.34.1 LANGUAGES C)
+project(gvm-libs VERSION 22.34.2 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)

=== debian/changelog ===
gvm-libs (22.34.2-1) unstable; urgency=medium

  * New upstream version 22.34.2
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 10:41:36 +0100

## gvm-libs 22.35.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 message("-- Configuring the Greenbone Vulnerability Management Libraries...")
 
 # VERSION: Always include major, minor and patch level.
-project(gvm-libs VERSION 22.34.2 LANGUAGES C)
+project(gvm-libs VERSION 22.35.3 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -317,24 +317,21 @@
   add_subdirectory(osp)
   add_subdirectory(gmp)
 
+  if(ENABLE_OPENVASD OR ENABLE_AGENTS OR ENABLE_CREDENTIAL_STORES)
+    add_subdirectory(http)
+  endif(ENABLE_OPENVASD OR ENABLE_AGENTS OR ENABLE_CREDENTIAL_STORES)
+
   if(ENABLE_OPENVASD)
-    add_subdirectory(http)
     add_subdirectory(http_scanner)
     add_subdirectory(openvasd)
     add_subdirectory(container_image_scanner)
   endif(ENABLE_OPENVASD)
 
   if(ENABLE_AGENTS)
-    if(NOT ENABLE_OPENVASD)
-      add_subdirectory(http)
-    endif(NOT ENABLE_OPENVASD)
     add_subdirectory(agent_controller)
   endif(ENABLE_AGENTS)
 
   if(ENABLE_CREDENTIAL_STORES)
-    if(NOT ENABLE_OPENVASD)
-      add_subdirectory(http)
-    endif(NOT ENABLE_OPENVASD)
     add_subdirectory(cyberark)
   endif(ENABLE_CREDENTIAL_STORES)
 endif(NOT SKIP_SRC)

=== debian/changelog ===
gvm-libs (22.35.3-1) unstable; urgency=medium

  * New upstream version 22.35.3
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 22 Jan 2026 14:43:31 +0100

## gvm-libs 22.35.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 message("-- Configuring the Greenbone Vulnerability Management Libraries...")
 
 # VERSION: Always include major, minor and patch level.
-project(gvm-libs VERSION 22.35.3 LANGUAGES C)
+project(gvm-libs VERSION 22.35.4 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)

=== debian/changelog ===
gvm-libs (22.35.4-1build1) resolute; urgency=medium

  * No-change rebuild for gpgme1.0 2.0

 -- Ural Tunaboyu <ural.tunaboyu@canonical.com>  Fri, 20 Feb 2026 19:45:13 +0000

gvm-libs (22.35.4-1) unstable; urgency=medium

  * New upstream version 22.35.4
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Fri, 30 Jan 2026 16:06:27 +0100

## gvm-libs 22.35.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,12 @@
 #
 # SPDX-License-Identifier: GPL-2.0-or-later
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.18)
 
 message("-- Configuring the Greenbone Vulnerability Management Libraries...")
 
 # VERSION: Always include major, minor and patch level.
-project(gvm-libs VERSION 22.35.4 LANGUAGES C)
+project(gvm-libs VERSION 22.35.8 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)

=== base/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2009-2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

include(FindPkgConfig)

if(NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif(NOT PKG_CONFIG_FOUND)

## Dependency checks

pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)

if($ENV{BUILD_SENTRY})
  find_package(SENTRY REQUIRED)
  if(${SENTRY_FOUND})
    message("Building with Sentry integration")
    set(SENTRY_LDFLAGS "-lsentry")
    set(SENTRY_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include")
    set(SENTRY_CFLAGS "-I${SENTRY_INCLUDE_DIR}")
    add_definitions(-DHAVE_SENTRY=1)
  endif(${SENTRY_FOUND})
endif($ENV{BUILD_SENTRY})

include_directories(${GLIB_INCLUDE_DIRS} ${SENTRY_INCLUDE_DIR})

set(
  FILES
  array.c
  credentials.c
  cvss.c
  drop_privileges.c
  hosts.c
  logging.c
  logging_domain.c
  networking.c
  nvti.c
  pidfile.c
  prefs.c
  proctitle.c
  pwpolicy.c
  gvm_sentry.c
  settings.c
  strings.c
  version.c
)

set(
  HEADERS
  array.h
  credentials.h
  cvss.h
  drop_privileges.h
  hosts.h
  logging.h
  logging_domain.h
  networking.h
  nvti.h
  pidfile.h
  prefs.h
  proctitle.h
  pwpolicy.h
  gvm_sentry.h
  settings.h
  strings.h
  version.h
)

if(BUILD_STATIC)
  set(LIBGVM_BASE_NAME gvm_base_static)
  add_library(gvm_base_static STATIC ${FILES})
  target_link_libraries(gvm_base_static m)
  set_target_properties(gvm_base_static PROPERTIES OUTPUT_NAME "gvm_base")
  set_target_properties(gvm_base_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  set_target_properties(gvm_base_static PROPERTIES PUBLIC_HEADER "${HEADERS}")
endif(BUILD_STATIC)

if(BUILD_SHARED)
  set(LIBGVM_BASE_NAME gvm_base_shared)
  add_library(gvm_base_shared SHARED ${FILES})
  set_target_properties(gvm_base_shared PROPERTIES OUTPUT_NAME "gvm_base")
  set_target_properties(gvm_base_shared PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  set_target_properties(
    gvm_base_shared
    PROPERTIES SOVERSION "${PROJECT_VERSION_MAJOR}"
  )
  set_target_properties(
    gvm_base_shared
    PROPERTIES VERSION "${CPACK_PACKAGE_VERSION}"
  )
  set_target_properties(gvm_base_shared PROPERTIES PUBLIC_HEADER "${HEADERS}")

  target_link_libraries(
    gvm_base_shared
    LINK_PRIVATE ${GLIB_LDFLAGS} ${LINKER_HARDENING_FLAGS} ${SENTRY_LDFLAGS} m
  )
endif(BUILD_SHARED)

set(LIBGVM_BASE_NAME ${LIBGVM_BASE_NAME} PARENT_SCOPE)

if(GVM_SYSCONF_DIR)
  add_definitions(-DGVM_SYSCONF_DIR="${GVM_SYSCONF_DIR}")
endif(GVM_SYSCONF_DIR)

## Tests

if(BUILD_TESTS)
  add_link_options(-g -lgcov --coverage)
  add_compile_options(-g -ftest-coverage -fprofile-arcs)

  add_unit_test(
    array-test
    array_tests.c
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    credentials-test
    credentials_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    cvss-test
    cvss_tests.c
    -lm
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )

  set(
    NETWORKING_TEST_LINKER_WRAP_OPTIONS
    "-Wl,-wrap,g_io_channel_new_file,-wrap,g_io_channel_shutdown,-wrap,g_io_channel_unref"
  )
  add_unit_test(
    networking-test
    networking_tests.c
    gvm_base_shared
    ${CGREEN_LIBRARIES}
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
    ${NETWORKING_TEST_LINKER_WRAP_OPTIONS}
  )
  add_unit_test(
    pidfile-test
    pidfile_tests.c
    gvm_util_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    prefs-test
    prefs_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    pwpolicy-test
    pwpolicy_tests.c
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    settings-test
    settings_tests.c
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    version-test
    version_tests.c
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    nvti-test
    nvti_tests.c
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    hosts-test
    hosts_tests.c
    gvm_base_shared
    gvm_util_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    logging-domain-test
    logging_domain_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    logging-test
    logging_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    strings-test
    strings_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
endif(BUILD_TESTS)

## Install

configure_file(libgvm_base.pc.in ${CMAKE_BINARY_DIR}/libgvm_base.pc @ONLY)

install(DIRECTORY DESTINATION ${GVM_RUN_DIR})

install(
  FILES ${CMAKE_BINARY_DIR}/libgvm_base.pc
  DESTINATION ${LIBDIR}/pkgconfig
)

if(BUILD_STATIC)
  install(
    TARGETS gvm_base_static
    RUNTIME DESTINATION ${BINDIR}
    ARCHIVE DESTINATION ${LIBDIR}
    PUBLIC_HEADER DESTINATION "${INCLUDEDIR}/gvm/base"
  )
endif(BUILD_STATIC)

if(BUILD_SHARED)
  install(
    TARGETS gvm_base_shared
    RUNTIME DESTINATION ${BINDIR}
    LIBRARY DESTINATION ${LIBDIR}
    ARCHIVE DESTINATION ${LIBDIR}
    PUBLIC_HEADER DESTINATION "${INCLUDEDIR}/gvm/base"
  )
endif(BUILD_SHARED)

## End

=== util/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2016-2023 Greenbone AG
#
# SPDX-License-Identifier: GPL-2.0-or-later

## Library

include(FindPkgConfig)

if(NOT PKG_CONFIG_FOUND)
  message(FATAL_ERROR "pkg-config executable not found. Aborting.")
endif(NOT PKG_CONFIG_FOUND)

## Dependency checks

# for all modules we need glib
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)

# for compressutils we need zlib
pkg_check_modules(ZLIB REQUIRED zlib>=1.2.8)

# for fileutils we need giolib
pkg_check_modules(GIO REQUIRED gio-2.0>=2.42)

# for serverutils, sshutils and xmlutils we need gnutls
pkg_check_modules(GNUTLS REQUIRED gnutls>=3.2.15)

# for uuidutils we need uuidlib
pkg_check_modules(UUID REQUIRED uuid>=2.25.0)

# for sshutils we need libssh
pkg_check_modules(LIBSSH REQUIRED libssh>=0.6.0)

# for kb we need libhiredis
pkg_check_modules(REDIS REQUIRED hiredis>=0.10.1)

# for fast XML we need libxml2
pkg_check_modules(LIBXML2 REQUIRED libxml-2.0>=2.0)

# for gpgmeutils we need libgpgme
pkg_check_modules(GPGME REQUIRED gpgme>=1.7.0)

# for serverutils we need libgcrypt
pkg_check_modules(GCRYPT REQUIRED libgcrypt)

# for json parsing we need cJSON
pkg_check_modules(CJSON REQUIRED libcjson>=1.7.14)

# for mqtt
find_library(LIBPAHO paho-mqtt3c)
message(STATUS "Looking for paho-mqtt3c ... ${LIBPAHO}")
if(NOT LIBPAHO)
  message(SEND_ERROR "libpaho-mqtt3c is required for MQTTv5 support.")
else(NOT LIBPAHO)
  set(LIBPAHO_LDFLAGS "paho-mqtt3c")
  add_definitions(-DHAVE_MQTT=1)
endif(NOT LIBPAHO)

message(STATUS "Looking for libcrypt...")
find_library(CRYPT crypt)
message(STATUS "Looking for libcrypt... ${CRYPT}")
if(NOT CRYPT)
  message(SEND_ERROR "The libcrypt library is required.")
else(NOT CRYPT)
  pkg_search_module(CRYPT_M QUIET libcrypt)
  if(DEFINED ${CRYPT_M_VERSION} AND ${CRYPT_M_VERSION} VERSION_GREATER "3.1.1")
    message(STATUS "\t Using external crypt_gensal_r of ... ${CRYPT_M_VERSION}")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DEXTERNAL_CRYPT_GENSALT_R=1")
  endif()
  set(CRYPT_LDFLAGS "-lcrypt")
endif(NOT CRYPT)

option(BUILD_WITH_RADIUS "Try to build with Radius support" ON)
option(BUILD_WITH_LDAP "Try to build with LDAP support" ON)

if(BUILD_WITH_RADIUS)
  #for radiusutils we need freeradius-client library
  message(STATUS "Looking for freeradius-client library...")
  find_library(LIBFREERADIUS freeradius-client)
  if(NOT LIBFREERADIUS)
    message(STATUS "Looking for radcli library...")
    find_library(LIBRADCLI radcli)
  endif(NOT LIBFREERADIUS)
  if(NOT LIBFREERADIUS AND NOT LIBRADCLI)
    message(
      STATUS
      "  No suitable radius library found - radius support disabled"
    )
  elseif(LIBFREERADIUS)
    message(STATUS "  Found ${LIBFREERADIUS} - radius support enabled")
    set(RADIUS_LDFLAGS "-lfreeradius-client")
    add_definitions(-DENABLE_RADIUS_AUTH=1 -DRADIUS_AUTH_FREERADIUS=1)
  elseif(LIBRADCLI)
    message(STATUS "  Found ${LIBRADCLI} - radius support enabled")
    set(RADIUS_LDFLAGS "-lradcli")
    add_definitions(-DENABLE_RADIUS_AUTH=1 -DRADIUS_AUTH_RADCLI=1)
  endif(NOT LIBFREERADIUS AND NOT LIBRADCLI)
endif(BUILD_WITH_RADIUS)

if(BUILD_WITH_LDAP)
  #for ldaputils we need ldap library
  message(STATUS "Looking for libldap...")
  find_library(LIBLDAP ldap2)
  if(NOT LIBLDAP)
    find_library(LIBLDAP ldap)
  endif(NOT LIBLDAP)
  if(NOT LIBLDAP)
    message(STATUS "  No ldap library found - ldap support disabled")
  else(NOT LIBLDAP)
    message(STATUS "  Found ${LIBLDAP} - ldap support enabled")
    add_definitions(-DENABLE_LDAP_AUTH=1)
    set(LDAP_LDFLAGS "-lldap")
  endif(NOT LIBLDAP)
endif(BUILD_WITH_LDAP)

include_directories(
  ${GLIB_INCLUDE_DIRS}
  ${GPGME_INCLUDE_DIRS}
  ${GCRYPT_INCLUDE_DIRS}
  ${LIBXML2_INCLUDE_DIRS}
)

set(
  FILES
  cpeutils.c
  passwordbasedauthentication.c
  compressutils.c
  fileutils.c
  gpgmeutils.c
  json.c
  jsonpull.c
  kb.c
  ldaputils.c
  nvticache.c
  mqtt.c
  radiusutils.c
  serverutils.c
  sshutils.c
  streamvalidator.c
  tlsutils.c
  uuidutils.c
  versionutils.c
  vtparser.c
  xmlutils.c
)

set(
  HEADERS
  cpeutils.h
  passwordbasedauthentication.h
  authutils.h
  compressutils.h
  fileutils.h
  gpgmeutils.h
  json.h
  jsonpull.h
  kb.h
  ldaputils.h
  nvticache.h
  mqtt.h
  radiusutils.h
  serverutils.h
  sshutils.h
  streamvalidator.h
  tlsutils.h
  uuidutils.h
  versionutils.h
  vtparser.h
  xmlutils.h
)

if(BUILD_STATIC)
  add_library(gvm_util_static STATIC ${FILES})
  set_target_properties(gvm_util_static PROPERTIES OUTPUT_NAME "gvm_util")
  set_target_properties(gvm_util_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  set_target_properties(gvm_util_static PROPERTIES PUBLIC_HEADER "${HEADERS}")
endif(BUILD_STATIC)

if(BUILD_SHARED)
  add_library(gvm_util_shared SHARED ${FILES})
  set_target_properties(gvm_util_shared PROPERTIES OUTPUT_NAME "gvm_util")
  set_target_properties(gvm_util_shared PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  set_target_properties(
    gvm_util_shared
    PROPERTIES SOVERSION "${PROJECT_VERSION_MAJOR}"
  )
  set_target_properties(
    gvm_util_shared
    PROPERTIES VERSION "${CPACK_PACKAGE_VERSION}"
  )
  set_target_properties(gvm_util_shared PROPERTIES PUBLIC_HEADER "${HEADERS}")

  target_link_libraries(
    gvm_util_shared
    LINK_PRIVATE
      gvm_base_shared
      ${LIBPAHO_LDFLAGS}
      ${GLIB_LDFLAGS}
      ${GIO_LDFLAGS}
      ${GPGME_LDFLAGS}
      ${ZLIB_LDFLAGS}
      ${RADIUS_LDFLAGS}
      ${LIBSSH_LDFLAGS}
      ${GNUTLS_LDFLAGS}
      ${GCRYPT_LDFLAGS}
      ${LDAP_LDFLAGS}
      ${REDIS_LDFLAGS}
      ${LIBXML2_LDFLAGS}
      ${UUID_LDFLAGS}
      ${LINKER_HARDENING_FLAGS}
      ${CRYPT_LDFLAGS}
      ${CJSON_LDFLAGS}
      ${VTPARSER_LDFLAGS}
  )
endif(BUILD_SHARED)

## Tests

if(BUILD_TESTS)
  add_unit_test(
    authutils-test
    authutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(json-test json_tests.c ${GLIB_LDFLAGS} ${CJSON_LDFLAGS})
  add_unit_test(jsonpull-test jsonpull_tests.c ${GLIB_LDFLAGS} ${CJSON_LDFLAGS})
  add_unit_test(
    passwordbasedauthentication-test
    passwordbasedauthentication_tests.c
    ${BSD_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${CRYPT_LDFLAGS}
    ${GLIB_LDFLAGS}
  )
  add_unit_test(
    compressutils-test
    compressutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    cpeutils-test
    cpeutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    fileutils-test
    fileutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    mqtt-test
    mqtt_tests.c
    gvm_util_shared
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${LIBPAHO_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    kb-test
    kb_tests.c
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    sshutils-test
    sshutils_tests.c
    gvm_util_shared
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    radiusutils-test
    radiusutils_tests.c
    gvm_util_shared
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    serverutils-test
    serverutils_tests.c
    gvm_util_shared
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    streamvalidator-test
    streamvalidator_tests.c
    gvm_util_shared
    gvm_base_shared
    ${GLIB_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    uuidutils-test
    uuidutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    versionutils-test
    versionutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    xmlutils-test
    xmlutils_tests.c
    ${GLIB_LDFLAGS}
    ${GIO_LDFLAGS}
    ${GPGME_LDFLAGS}
    ${ZLIB_LDFLAGS}
    ${RADIUS_LDFLAGS}
    ${LIBSSH_LDFLAGS}
    ${GNUTLS_LDFLAGS}
    ${GCRYPT_LDFLAGS}
    ${LDAP_LDFLAGS}
    ${REDIS_LDFLAGS}
    ${LIBXML2_LDFLAGS}
    ${UUID_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
  add_unit_test(
    vtparser-test
    vtparser_tests.c
    gvm_base_shared
    gvm_util_shared
    ${GLIB_LDFLAGS}
    ${CJSON_LDFLAGS}
    ${VTPARSER_LDFLAGS}
    ${LINKER_HARDENING_FLAGS}
  )
endif(BUILD_TESTS)

## Install
configure_file(libgvm_util.pc.in ${CMAKE_BINARY_DIR}/libgvm_util.pc @ONLY)

install(
  FILES ${CMAKE_BINARY_DIR}/libgvm_util.pc
  DESTINATION ${LIBDIR}/pkgconfig
)

if(BUILD_STATIC)
  install(
    TARGETS gvm_util_static
    RUNTIME DESTINATION ${BINDIR}
    ARCHIVE DESTINATION ${LIBDIR}
    PUBLIC_HEADER DESTINATION "${INCLUDEDIR}/gvm/util"
  )
endif(BUILD_STATIC)

if(BUILD_SHARED)
  install(
    TARGETS gvm_util_shared
    RUNTIME DESTINATION ${BINDIR}
    LIBRARY DESTINATION ${LIBDIR}
    ARCHIVE DESTINATION ${LIBDIR}
    PUBLIC_HEADER DESTINATION "${INCLUDEDIR}/gvm/util"
  )
endif(BUILD_SHARED)

## End

=== debian/changelog ===
gvm-libs (22.35.8-1) unstable; urgency=medium

  * New upstream version 22.35.8
  * Refresh patches
  * Bump Standards-Version to 4.7.3 (no change)

 -- Sophie Brun <sophie@kali.org>  Tue, 24 Feb 2026 16:14:11 +0100

gvm-libs (22.35.6-1) unstable; urgency=medium

  * New upstream version 22.35.6
  * Update debian/copyright
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 12 Feb 2026 11:30:57 +0100

=== debian/control ===
Source: gvm-libs
Section: libs
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
	       libcgreen1-dev [!ppc64el !s390x],
	       libcjson-dev,
	       libcrypt-dev,
	       libcurl4-gnutls-dev,
               libgcrypt-dev,
               libglib2.0-dev,
               libgpgme-dev,
               libgnutls28-dev,
               libldap2-dev,
	       libnet1-dev,
	       libpaho-mqtt-dev,
	       libpcap-dev,
               libssh-dev,
               libhiredis-dev,
               libradcli-dev,
               libxml2-dev,
               pkgconf,
               uuid-dev
Build-Depends-Indep: doxygen
Homepage: https://www.greenbone.net/
Vcs-Browser: https://salsa.debian.org/pkg-security-team/gvm-libs
Vcs-Git: https://salsa.debian.org/pkg-security-team/gvm-libs.git
Standards-Version: 4.7.3
Rules-Requires-Root: no

Package: libgvm-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libgcrypt-dev,
         libglib2.0-dev,
         libgnutls28-dev,
         libgpgme-dev,
         libhiredis-dev,
         libksba-dev,
         libgvm22t64 (= ${binary:Version}),
         libpcap-dev,
         libssh-dev,
         uuid-dev,
         libsnmp-dev
Suggests: libgvm-doc
Description: remote network security auditor - static libraries and headers
 The Open Vulnerability Assessment System is a modular security auditing
 tool, used for testing remote systems for vulnerabilities that should be
 fixed.
 .
 It is made up of two parts: a server, and a client. The server/daemon,
 gvmd, is in charge of the attacks, whereas the client,
 gvm-tools, provides an X11/GTK+ user interface.
 .
 This package contains the required static libraries and headers.

Package: libgvm-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: remote network security auditor - libraries documentation
 The Open Vulnerability Assessment System is a modular security auditing
 tool, used for testing remote systems for vulnerabilities that should be
 fixed.
 .
 It is made up of two parts: a server, and a client. The server/daemon,
 gvmd, is in charge of the attacks, whereas the client,
 gvm-tools, provides an X11/GTK+ user interface.
 .
 This package contains the doxygen generated HTML documentation for the
 libraries.


Package: libgvm22t64
Provides: ${t64:Provides}
Breaks: libgvm22 (<< ${source:Version})
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Replaces: libgvm22, libopenvas9
Conflicts: libopenvas9
Description: remote network security auditor - shared libraries
 The Open Vulnerability Assessment System is a modular security auditing
 tool, used for testing remote systems for vulnerabilities that should be
 fixed.
 .
 It is made up of two parts: a server, and a client. The server/daemon,
 gvmd, is in charge of the attacks, whereas the client,
 gvm-tools, provides an X11/GTK+ user interface.
 .
 This package contains the required shared libraries.
